CREATE OR REPLACE
TRIGGER CDPATRIBEMATIVO_BEMATIVO BEFORE INSERT OR UPDATE OR DELETE ON BEMATIVO 
FOR EACH ROW 
BEGIN
   IF INSERTING OR UPDATING THEN
      IF :NEW.CDPATRIBEMATIVO = :NEW.CDBEMATIVO THEN
        :NEW.CDPATRIBEMATIVO :=  SUBSTR(:NEW.CDPATRIBEMATIVO, 05, 06);
      ELSE 
         IF LENGTH(:NEW.CDPATRIBEMATIVO) > 6 THEN
            RAISE_APPLICATION_ERROR(-20001, 'No foi possvel incluir o bem '||:NEW.NMBEMATIVO||'. No  permitido inserir um cdigo de patrimnio com mais de 06 caracteres.');
         ELSE
            /* Passa o Cdigo de Patrimnio para 06 caracteres*/
            :NEW.CDPATRIBEMATIVO :=  LPAD(:NEW.CDPATRIBEMATIVO, 06, '0');
         END IF;     
      END IF;
   END IF;
   IF DELETING THEN
      IF :OLD.CDBEMPRINCIPAL IS NOT NULL THEN
         FOR P_BEM IN ( SELECT NMBEMATIVO
                 FROM BEMATIVO
                WHERE CDEMPRESA = :OLD.CDEMPRESA 
                  AND CDBEMATIVO = :OLD.CDBEMPRINCIPAL) LOOP
      
              RAISE_APPLICATION_ERROR(-20001, 'No foi possvel Excluir o bem '||:OLD.NMBEMATIVO||'. Bem est agregado ao bem '||P_BEM.NMBEMATIVO||'.');
         END LOOP;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CDPATRIBEMATIVO_BEMATIVO','5.50.000'); END;
/
